#!/usr/bin/perl
#
# See LICENSE for copyright information
#
# check_meta.pl <host> [port] 
#
# NetSaint host script to check metastat on Disk Suite Sun System
# running netsaint_statd.
#

require 5.003;
BEGIN { $ENV{PATH} = '/bin' }
use Socket;
use POSIX;
use strict;

sub usage;

my $TIMEOUT = 15;

my %ERRORS = ('UNKNOWN', '2',
		'OK', '0',
		'WARNING', '1',
		'CRITICAL', '2');
my $remote = shift || &usage(%ERRORS);
my $port = shift || 1040;

my $remoteaddr = inet_aton("$remote");
my $paddr = sockaddr_in($port, $remoteaddr) || die "Can't create info for connection: #!\n";;
my $proto = getprotobyname('tcp');
socket(Server, PF_INET, SOCK_STREAM, $proto) || die "Can't create socket: $!";
setsockopt(Server, SOL_SOCKET, SO_REUSEADDR, 1);
#connect(Server, $paddr) || die "Can't connect to server: $!";

my $state = "OK";
my $answer = undef;

# Just in case of problems, let's not hang NetSaint
$SIG{'ALRM'} = sub { 
     close(Server);
     select(STDOUT);
     print "No_Answer_from_Client\n";
     exit $ERRORS{"UNKNOWN"};
};
alarm($TIMEOUT);

connect(Server, $paddr) || die "Can't connect to server: $!";

select(Server);
$| = 1;
	print Server "meta\n";
my ($servanswer) = <Server>;
alarm(0);
close(Server);
select(STDOUT);


$state = "UNKNOWN";
$answer = "Meta_state_unknown!\n";

if ($servanswer eq "0") {
	$answer = "OK\n";
	$state = "OK";
	} else {
		$state = "CRITICAL";
		$answer = "Error_run_metastat_on_server\n";
}
			

print $answer;
exit $ERRORS{$state};

sub usage {
        print "Minimum arguments not supplied!\n";
        print "\n";
        print "Perl Check Process plugin for NetSaint\n";
        print "Copyright (c) 1999 Charlie Cook & Nick Reinking\n";
        print "\n";
        print "Usage: $0 <host> [<port>]\n";
        print "\n";
        print "<port> = Port that the status daemon is running on <host>.\n	Defaults to 1040.\n";
        exit $ERRORS{"UNKNOWN"};
}
